--
-- MapSiloSave
--
-- M@D Author  Headshot XXL
-- M@D date 14.11.2009
--
-- > Copyright (C) Headshot XXL - www.planet-ls.de < --

print("Map: SaveSilo loaded");

MapSiloSave = {};

function MapSiloSave:loadMap(name)
	
	local dir = getUserProfileAppPath() .. "savegame"..gameMenuSystem.quickPlayMenu.selectedIndex;
    self.siloSaveXML = dir .. "/silo.xml";	
	
	self.saveTipTriggers = g_currentMission.tipTriggers;
	
	if g_missionLoaderDesc.stats.fuelUsage == 0 then
		os.remove(self.siloSaveXML);		
	else
		self:loadSiloFromFile()
	end;

end;

function MapSiloSave:deleteMap()
end;

function MapSiloSave:delete()
end;

function MapSiloSave:mouseEvent(posX, posY, isDown, isUp, button)
end;

function MapSiloSave:keyEvent(unicode, sym, modifier, isDown)
end;

function MapSiloSave:update(dt)
end;

function MapSiloSave:draw()
end;

function MapSiloSave:saveSiloToXML()	
	
	local existDir = io.open (self.siloSaveXML, "w");	
	if existDir == nil then
		createXMLFile("createsilo", self.siloSaveXML, "savesilo");
	end;

    -- save silo filllevel
    local siloFile = io.open (self.siloSaveXML, "w");
    if siloFile ~= nil then
        siloFile:write('<?xml version="1.0" encoding="iso-8859-1" standalone="no" ?>\n<siloSaves>\n');

        if g_currentMission ~= nil then
			for i=1, table.getn(self.saveTipTriggers) do
				if self.saveTipTriggers[i].movingId ~= nil then
					local x,y,z = getTranslation(self.saveTipTriggers[i].movingId);
					if self.saveTipTriggers[i].yBackup ~= nil then
						siloFile:write('    <silo yHeight="'..y..'" name="'..getName(self.saveTipTriggers[i].triggerId)..'" yBackup="'..self.saveTipTriggers[i].yBackup..'" />\n');
					else
						siloFile:write('    <silo yHeight="'..y..'" name="'..getName(self.saveTipTriggers[i].triggerId)..'" yBackup="'..y..'" />\n');
					end;
				end;
			end;
        end;

        siloFile:write("</siloSaves>");

        siloFile:close();
    end;	
	
end;

function MapSiloSave:loadSiloFromFile()

	local existDir = io.open (self.siloSaveXML, "r");
	if existDir ~= nil then
		local xmlFile = loadXMLFile("TempConfig", self.siloSaveXML);
	
		local siloI = 0;
		for i=1, table.getn(self.saveTipTriggers) do 
			if self.saveTipTriggers[i].movingId ~= nil then
	
				local key = string.format("siloSaves.silo(%d)", siloI);
				local yHeight = getXMLFloat(xmlFile, key.."#yHeight");
				local name = getXMLString(xmlFile, key.."#name");
				local yBackup = getXMLFloat(xmlFile, key.."#yBackup");
				if yHeight == nil or name == nil or yBackup == nil then
					break;
				end;									
					local x,y,z = getTranslation(self.saveTipTriggers[i].movingId);
					setTranslation(self.saveTipTriggers[i].movingId, x, yHeight ,z);				
					self.saveTipTriggers[i].yBackup = yBackup;
					
				siloI = siloI +1;
			end;
		end;
		
		delete(xmlFile);
		print("TipTrigger FillLevel loaded");
	else
		print("Warning: ", self.siloSaveXML, " can not be found, TipTrigger FillLevel not loaded.");
	end;

end;

local QuickPlayMenuSaveSelectedGame = QuickPlayMenu.saveSelectedGame;
QuickPlayMenu.saveSelectedGame = function(self)
	QuickPlayMenuSaveSelectedGame(self); 
	MapSiloSave:saveSiloToXML();
end;

addModEventListener(MapSiloSave);

